#open "graphics" ;;

random__init 0 ;;

open_graph "" ;; (* 480 * 280 *)

cd "Rebma:Perso:Essais en Caml:Poly.ml:" ;;

include "Tsai.ml" ;;

(* -------------------------------------------------------------- *)


let moveTo (ax,ay) = moveto (int_of_float ax) (int_of_float ay) ;;

let lineTo (ax,ay) = lineto (int_of_float ax) (int_of_float ay) ;;

let trace_triangle a b c = moveTo a ; lineTo b ; lineTo c ; lineTo a ;;

let trace_cercle (ax,ay) r = 
	draw_circle (int_of_float ax) (int_of_float ay) (int_of_float r) ;;
	
let trace_cercle_circonscrit a b c =
	let o,r = cercle_circonscrit a b c
	in
	trace_cercle o r ;;

exception Gagn of point list ;;

let rec liste_alatoire = function
	  0 -> []
	| taille -> let l = liste_alatoire (taille - 1)
				in
				try while true do
					let a = (120.+.(random__float 240.),20.+.(random__float 240.))
					in
					if not (mem a l) then raise (Gagn(a :: l))
					done ;
					l
				with Gagn res -> res ;;
				
let trace_point (ax,ay) = fill_circle (int_of_float ax)  (int_of_float ay) 3 ;;

let trace_liste_de_points l = do_list trace_point l ;;

let traceTriangle (a,b,c) =
	trace_liste_de_points [ a ; b ; c ] ;
	trace_triangle a b c ;;
	
let trace_triangulation = map traceTriangle ;;

let trace_Delaunay l = trace_triangulation (tsai l) ;;
	
let infini (ax,ay) (dx,dy) = (ax +. 20.*.dx,ay +. 20.*.dy) ;;

let trace_objet_du_diagramme = function
	  Segment(a,b) -> moveTo a ; lineTo b
	| Demi_droite(a,d) -> moveTo a ; lineTo (infini a d) ;;
	
let trace_diagramme = map trace_objet_du_diagramme ;;

let attend () = wait_next_event [ Button_down ; Key_pressed ] ;
				if key_pressed () then ( read_key () ; () )
				(* ; sound 1000 100 *) ; () ;;

let test nb_points nb_tests =
	for i = 1 to nb_tests do
		clear_graph () ;
		let l = liste_alatoire nb_points
		in
		let t,v = voronoi_et_delaunay l
		in
		set_line_width 2 ; trace_triangulation t ;
		set_line_width 1 ; trace_diagramme v ;
		if i < nb_tests then attend ()
	done ;;
